const Dsig = require('pkcs11-xml');
const fs = require('fs');

var dsig = new Dsig('/usr/lib/x86_64-linux-gnu/pkcs11/opensc-pkcs11.so');

try {
    dsig.openSession('12345678');
    const claves = dsig.getPrivateKeys();
    for (let i = 0; i < claves.length; i++) {
        console.log(claves[i].label);
    }
    dsig.privateKey = claves[0].label;
    var xml = '<libro><titulo>Viaje al centro de la tierra</titulo><autor>Julio Berne</autor></libro>';
    console.log(dsig.computeSignature(xml, 'titulo'));
    fs.writeFileSync('/tmp/xml.xml', dsig.computeSignature(xml, 'titulo'));
} catch(e) {
    console.error(e);
} finally {
    dsig.closeSession();
}
